//	This is a simple tool for applying the framerate unlock modifications to SR2_pc.exe, 
//	as applied by the (Windows) tool by Zyankali:
//	https://www.gog.com/forum/saints_row_series/instructions_how_to_completely_remove_the_30fps_cap_from_saints_row_2
//	This can also re-enable the lock with "sr2-unlock SR2_pc.exe lock"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

void putbytes(FILE *fp, unsigned addr, char *src, int numbytes);

int main(int argc, char **argv)
{

	if (argc != 3) {
		printf("Usage: sr2-unlock <SR2_pc.exe> <lock/unlock>\n");
		return 0;
	}

	char unlock[] = "\xE8\xD1\xF4\xFF\xFF\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0";
	char lock[] = "\xE9\x95\x64\x9\x0\x90\xB9\x1\x90\xE2\xFD\x90\x90\x90\xE8\x2B\x90\xF6\xFF\xE9\x55\x9B\xF6\xFF";
	FILE *fp;
	char *patch;

	if (!strcmp(argv[2], "lock"))
		patch=lock;
	else
		patch=unlock;

	if ((fp = fopen(argv[1], "r+b")) == 0) {
		printf("ERROR: could not open %s\n", argv[1]);
		return 1;
	}

	putbytes(fp, 0x920D5A, patch, 5);
	putbytes(fp, 0x9B71F4, patch+5, 2);
	putbytes(fp, 0x9B71F9, patch+7, 17);

	return 0;
}

void putbytes(FILE *fp, unsigned addr, char *source, int numbytes)
{
	fseek(fp, addr, 0);
	for (int x = 0; x < numbytes; x++)
		fputc(*(source+x), fp);
	return;
}
